// The following code is example code from 
// "ActionScript 3.0 Bible, 2nd Edition" by Roger Braunstein
// Find all of the source code on the companion website
// http://actionscriptbible.com/
//
// Copyright (c) 2010 by Wiley Publishing, Inc., Indianapolis, Indiana
//
// Permission is hereby granted, free of charge, to any person
// obtaining a copy of this software and associated documentation
// files (the "Software"), to deal in the Software without
// restriction, including without limitation the rights to use,
// copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the
// Software is furnished to do so, subject to the following
// conditions:
//
// The above copyright notice and this permission notice shall be
// included in all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
// OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
// NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
// HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
// FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
// OTHER DEALINGS IN THE SOFTWARE.

package {
  import com.actionscriptbible.Example;
  import com.actionscriptbible.xmlns.mx;
  import com.actionscriptbible.xmlns.s;
  
  public class ch11ex4 extends Example {
    private const MXML:XML =
      <s:Application
         xmlns:fx="http://ns.adobe.com/mxml/2009"
         xmlns:s="library://ns.adobe.com/flex/spark"
         xmlns:mx="library://ns.adobe.com/flex/halo">
         <s:Button label="Test" id="myButton"/>
         <mx:Slider direction="horizontal" id="mySlider"/>
         <fx:Script><![CDATA[
             protected const AUTHOR:String = "roger";
         ]]></fx:Script>
      </s:Application>
      
    public function ch11ex4() {
      trace(MXML.mx::Slider.toXMLString()); //<mx:Slider...
      trace(MXML.s::Button.toXMLString()); //<s::Button...
      var fx:Namespace = new Namespace("http://ns.adobe.com/mxml/2009");
      trace(MXML.fx::*.toXMLString()); //<fx:Script...
      trace(MXML.*::Button.toXMLString()); //<mx::Button...
      
      
      var buttonNS:Namespace = MXML.*::Button.namespace();
      trace(buttonNS.prefix, buttonNS.uri); //s library://ns.adobe.com/flex/spark
      trace(MXML.buttonNS::Button.toXMLString()); //<s:Button...
      
      var somenode:XML = MXML.*::Slider[0]; //get the Slider node
      var sNS:Namespace = somenode.namespace("s");
      trace(sNS.prefix, sNS.uri); //s library://ns.adobe.com/flex/spark
      
      for each (var ns:Namespace in MXML.namespaceDeclarations()) {
        trace(ns.prefix, ns.uri);
      }
      //fx http://ns.adobe.com/mxml/2009
      //s library://ns.adobe.com/flex/spark
      //mx library://ns.adobe.com/flex/halo      
    } 
  }
}
