// The following code is example code from 
// "ActionScript 3.0 Bible, 2nd Edition" by Roger Braunstein
// Find all of the source code on the companion website
// http://actionscriptbible.com/
//
// Copyright (c) 2010 by Wiley Publishing, Inc., Indianapolis, Indiana
//
// Permission is hereby granted, free of charge, to any person
// obtaining a copy of this software and associated documentation
// files (the "Software"), to deal in the Software without
// restriction, including without limitation the rights to use,
// copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the
// Software is furnished to do so, subject to the following
// conditions:
//
// The above copyright notice and this permission notice shall be
// included in all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
// OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
// NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
// HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
// FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
// OTHER DEALINGS IN THE SOFTWARE.

package {
  import com.actionscriptbible.Example;
  
  public class ch12ex3 extends Example {
    public function ch12ex3() {
      //IDENTIFYING
      trace("---- exec()");
      var contactNumbers:String =
        "Call us at one of these numbers.\n" +
        "Los Angeles: 310-555-2910\n" +
        "New York: 212-555-2499\n" +
        "Boston: 617-555-7141";
      var phoneNumber:RegExp = /\d{3}-\d{3}-\d{4}/g;
      var result:Object;
      while(result = phoneNumber.exec(contactNumbers)) {
        trace(result[0]); //prints out the phone numbers one by one
      }

      trace("---- match()");
      var contactNumbers:String = 
          "Call us at one of these numbers.\n" +
          "Los Angeles: 310-555-2910\n" + 
          "New York: 212-555-2499\n" + 
          "Boston: 617-555-7141";
      var matches:Array = contactNumbers.match(/\d{3}-\d{3}-\d{4}/g);
      if (matches) {
          trace(matches.length); //3
          trace(matches[0]); //310-555-2910
      }
    }
  }
}