// The following code is example code from 
// "ActionScript 3.0 Bible, 2nd Edition" by Roger Braunstein
// Find all of the source code on the companion website
// http://actionscriptbible.com/
//
// Copyright (c) 2010 by Wiley Publishing, Inc., Indianapolis, Indiana
//
// Permission is hereby granted, free of charge, to any person
// obtaining a copy of this software and associated documentation
// files (the "Software"), to deal in the Software without
// restriction, including without limitation the rights to use,
// copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the
// Software is furnished to do so, subject to the following
// conditions:
//
// The above copyright notice and this permission notice shall be
// included in all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
// OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
// NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
// HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
// FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
// OTHER DEALINGS IN THE SOFTWARE.

package {
  import com.actionscriptbible.Example;
  
  public class ch12ex5 extends Example {
    public function ch12ex5() {
      //REPLACING
      
      trace("---- replacing strings");
      var quote:String = "I did it for the money and the ladies.";
      quote = quote.replace("money", "learning experience");
      quote = quote.replace("ladies", "sleep deprivation");
      trace(quote);
      //I did it for the learning experience and the sleep deprivation.
      
      trace("---- replacing patterns");
      var document:String = "My name is John Doe, SSN 123-45-6789," +
          "I live at 120 Birch st...";
      var ssn:RegExp = /\d{3}-\d{2}-\d{4}/g;
      document = document.replace(ssn, "<SSN REMOVED>");
      trace(document);
      //My name is John Doe, SSN <SSN REMOVED>, I live at 120 Birch st...

      trace("---- replacing with capture groups");
      var introduction:String = 
      "My name is Roger; but I’ll have you know MY name is Henry!";
      trace(introduction.replace(/my name is (\w+)/gi, "$1 is my name"));
      //Roger is my name; but I’ll have you know Henry is my name!
      
      trace("---- replacing with a function");
      var friends:RegExp = /aashoo|betty|cesar|deepa|eve|frej|gina|hilary|isabell/gi;
      var fixCaps:Function = function fixCaps(...args):String {
          var match:String = String(args[0]);
          return match.charAt(0).toUpperCase() + match.substr(1).toLowerCase();
      }
      
      var txt:String = "DEEPA is in SF cESaR is in Bogota and isaBELL is in Berlin.";
      trace(txt.replace(friends, fixCaps));
      //Deepa is in SF Cesar is in Bogota and Isabell is in Berlin.
    }
  }
}