// The following code is example code from 
// "ActionScript 3.0 Bible, 2nd Edition" by Roger Braunstein
// Find all of the source code on the companion website
// http://actionscriptbible.com/
//
// Copyright (c) 2010 by Wiley Publishing, Inc., Indianapolis, Indiana
//
// Permission is hereby granted, free of charge, to any person
// obtaining a copy of this software and associated documentation
// files (the "Software"), to deal in the Software without
// restriction, including without limitation the rights to use,
// copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the
// Software is furnished to do so, subject to the following
// conditions:
//
// The above copyright notice and this permission notice shall be
// included in all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
// OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
// NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
// HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
// FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
// OTHER DEALINGS IN THE SOFTWARE.

package {
  import flash.display.Sprite;
  import flash.events.Event;
  public class ch15ex3 extends Sprite {
    protected var canvas:Canvas;
    public function ch15ex3() {
      canvas = new Canvas(400, 300);
      addChild(canvas);
      canvas.x = stage.stageWidth/2;
      canvas.y = stage.stageHeight/2;
      canvas.rotationY = 25;
      addEventListener(Event.ENTER_FRAME, onEnterFrame);
    }
    protected function onEnterFrame(event:Event):void {
      canvas.rotationY += 0.2;
      canvas.rotationX += 0.04;
    }
  }
}
import flash.display.Shape;
import flash.display.Sprite;
import flash.events.MouseEvent;
import flash.geom.Rectangle;
class Canvas extends Sprite {
  protected var fg:Shape, bg:Shape;
  protected var ink:int = 0;
  public function Canvas(w:Number, h:Number) {
    bg = new Shape();
    bg.graphics.beginFill(0xe0e0e0, 1);
    bg.graphics.drawRect(0, 0, w, h);
    bg.x = -w/2; bg.y = -h/2;
    addChild(bg);
    fg = new Shape();
    fg.x = -w/2; fg.y = -h/2;
    addChild(fg);
    fg.scrollRect = new Rectangle(-w/2, -h/2, w, h);
    addEventListener(MouseEvent.MOUSE_MOVE, onMouseMove);
  }
  protected function onMouseMove(event:MouseEvent):void {
    if (event.buttonDown) {
      ink++;
      fg.graphics.lineTo(event.localX, event.localY);
    } else {
      if (ink > 500) {
        fg.graphics.clear();
        ink = 0;
      }
      fg.graphics.lineStyle(32, 0xffffff * Math.random(), 0.4);
      fg.graphics.moveTo(event.localX, event.localY);
    }
  }
}