// The following code is example code from 
// "ActionScript 3.0 Bible, 2nd Edition" by Roger Braunstein
// Find all of the source code on the companion website
// http://actionscriptbible.com/
//
// Copyright (c) 2010 by Wiley Publishing, Inc., Indianapolis, Indiana
//
// Permission is hereby granted, free of charge, to any person
// obtaining a copy of this software and associated documentation
// files (the "Software"), to deal in the Software without
// restriction, including without limitation the rights to use,
// copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the
// Software is furnished to do so, subject to the following
// conditions:
//
// The above copyright notice and this permission notice shall be
// included in all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
// OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
// NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
// HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
// FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
// OTHER DEALINGS IN THE SOFTWARE.

package {
  import flash.display.Sprite;
  import flash.events.MouseEvent;
  import flash.text.*;
 
  public class ch17ex11 extends Sprite {
    protected var tf:TextField;
    protected const RED:TextFormat = new TextFormat("_serif", 28, 0xff0000);
    protected const BLACK:TextFormat = new TextFormat("_serif", 28, 0);
    
    public function ch17ex11()
    {
      tf = new TextField();
      tf.multiline = true;
      tf.wordWrap = true;
      tf.width = 450;
      tf.autoSize = TextFieldAutoSize.LEFT;
      tf.addEventListener(MouseEvent.MOUSE_MOVE, onMouseMove);
      tf.addEventListener(MouseEvent.MOUSE_OUT, onMouseOut);
      tf.defaultTextFormat = BLACK;
      tf.text = "Alice was beginning to get very tired of sitting by her \
sister on the bank, and of having nothing to do: once or twice she had peeped \
into the book her sister was reading, but it had no pictures or conversations \
in it, 'and what is the use of a book,' thought Alice, 'without pictures or \
conversation?'";

      addChild(tf);
    }
    
    protected function onMouseMove(mouseEvent:MouseEvent):void {
      var charInText:int = tf.getCharIndexAtPoint(10, tf.mouseY);
      if (charInText == -1) return;
      var lineIndex:int = tf.getLineIndexOfChar(charInText);
      var firstCharIndex:int = tf.getLineOffset(lineIndex);
      var lastCharIndex:int = firstCharIndex + tf.getLineLength(lineIndex);
  
      //we want to set all the TextField to black except
      //the text underneath the mouse
      tf.setTextFormat(BLACK);
      tf.setTextFormat(RED, firstCharIndex, lastCharIndex);
    }
    
    protected function onMouseOut(mouseEvent:MouseEvent):void {
      tf.setTextFormat(BLACK);
    }
  }
}