// The following code is example code from 
// "ActionScript 3.0 Bible, 2nd Edition" by Roger Braunstein
// Find all of the source code on the companion website
// http://actionscriptbible.com/
//
// Copyright (c) 2010 by Wiley Publishing, Inc., Indianapolis, Indiana
//
// Permission is hereby granted, free of charge, to any person
// obtaining a copy of this software and associated documentation
// files (the "Software"), to deal in the Software without
// restriction, including without limitation the rights to use,
// copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the
// Software is furnished to do so, subject to the following
// conditions:
//
// The above copyright notice and this permission notice shall be
// included in all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
// OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
// NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
// HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
// FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
// OTHER DEALINGS IN THE SOFTWARE.

package {
  import flash.display.Sprite;
  import flash.events.MouseEvent;
  import flash.geom.Rectangle;
  import flash.text.TextField;
  import flash.text.TextFormat;
  import flash.utils.setTimeout;
  
  public class ch17ex12 extends Sprite {
    protected var letters:Vector.<LetterField> = new Vector.<LetterField>();
    
    public function ch17ex12() {
      var text:String = "Are you watching closely?";
      var sourceTF:TextField = newTF();
      sourceTF.text = text;
      sourceTF.border = true;
      sourceTF.width = sourceTF.textWidth;
      addChild(sourceTF);

      //break it up into letters
      for (var i:int = 0; i < text.length; i++) {
        var lf:LetterField = new LetterField(newTF());
        var letterBounds:Rectangle = sourceTF.getCharBoundaries(i);
        lf.x = letterBounds.x;
        lf.y = letterBounds.y;
        lf.letter = text.charAt(i);
        addChild(lf);
        letters.push(lf);
      }
      
      //remove original
      removeChild(sourceTF);
      stage.addEventListener(MouseEvent.CLICK, startAnimation);
    }
    
    protected function startAnimation(event:MouseEvent):void {
      for (var i:int = 0; i < letters.length; i++) {
        setTimeout(letters[i].startAnimation, i * 30);
      }
    }
    
    protected function newTF():TextField {
      var tf:TextField = new TextField();
      tf.defaultTextFormat = new TextFormat("_serif", 38, 0, false, false);
      tf.selectable = false;
      tf.width = tf.height = 50;
      return tf;
    }
  }
}

import flash.text.TextField;
import flash.display.Sprite;
import flash.events.Event;
class LetterField extends Sprite {
  protected var tf:TextField;
  protected const factor:Number = 1 - 0.08;
  public function LetterField(tf:TextField) {
    this.tf = tf;
    addChild(tf);
  }
  public function set letter(ltr:String):void {
    tf.text = ltr;
    tf.x = -tf.textWidth / 2;
    this.x -= tf.x;
  }
  public function startAnimation():void {
    addEventListener(Event.ENTER_FRAME, tick);
  }
  protected function tick(event:Event):void {
    this.alpha *= factor;
    this.rotationY = 180 * (1-alpha);
  }
}