// The following code is example code from 
// "ActionScript 3.0 Bible, 2nd Edition" by Roger Braunstein
// Find all of the source code on the companion website
// http://actionscriptbible.com/
//
// Copyright (c) 2010 by Wiley Publishing, Inc., Indianapolis, Indiana
//
// Permission is hereby granted, free of charge, to any person
// obtaining a copy of this software and associated documentation
// files (the "Software"), to deal in the Software without
// restriction, including without limitation the rights to use,
// copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the
// Software is furnished to do so, subject to the following
// conditions:
//
// The above copyright notice and this permission notice shall be
// included in all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
// OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
// NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
// HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
// FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
// OTHER DEALINGS IN THE SOFTWARE.

package
{
  import flash.display.Sprite;
  import flash.events.Event;
  import flash.net.URLLoader;
  import flash.net.URLRequest;
  import flash.text.TextField;
  import flash.text.TextFormat;

  public class ch17ex13 extends Sprite {
    protected var tf:TextField;
    protected var progressBar:Sprite;
    
    public function ch17ex13() {
      tf = new TextField();
      var fmt:TextFormat = new TextFormat("_serif", 24, 0x303030);
      fmt.leading = 10;
      fmt.leftMargin = fmt.rightMargin = 10;
      fmt.indent = 20;
      tf.defaultTextFormat = fmt;
      tf.multiline = tf.wordWrap = true;
      tf.mouseWheelEnabled = true;
      tf.height = stage.stageHeight;
      tf.width = stage.stageWidth;
      tf.text = "Loading...";
      addChild(tf);
      
      progressBar = new Sprite();
      progressBar.graphics.beginFill(0, 0.1);
      progressBar.graphics.drawRect(0, 0, stage.stageWidth, 60);
      progressBar.graphics.endFill();
      addChildAt(progressBar, 0);
  
      var loader:URLLoader = new URLLoader(new URLRequest(
        "http://actionscriptbible.com/files/alice-ch1.txt"));
      loader.addEventListener(Event.COMPLETE, onLoadComplete);
    }
    
    protected function onLoadComplete(event:Event):void {
      tf.text = URLLoader(event.target).data;
      tf.addEventListener(Event.ENTER_FRAME, scrollTextField);
      stage.frameRate = 15;
    }
    
    protected function scrollTextField(event:Event):void {
      var margin:Number = 50;
      if (stage.mouseY < margin) tf.scrollV--;
      if (stage.mouseY > stage.stageHeight - margin) tf.scrollV++;
      progressBar.y = (stage.stageHeight - progressBar.height)
        * (tf.scrollV / tf.maxScrollV);
    }
  }
}