// The following code is example code from 
// "ActionScript 3.0 Bible, 2nd Edition" by Roger Braunstein
// Find all of the source code on the companion website
// http://actionscriptbible.com/
//
// Copyright (c) 2010 by Wiley Publishing, Inc., Indianapolis, Indiana
//
// Permission is hereby granted, free of charge, to any person
// obtaining a copy of this software and associated documentation
// files (the "Software"), to deal in the Software without
// restriction, including without limitation the rights to use,
// copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the
// Software is furnished to do so, subject to the following
// conditions:
//
// The above copyright notice and this permission notice shall be
// included in all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
// OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
// NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
// HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
// FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
// OTHER DEALINGS IN THE SOFTWARE.

package {
  import flash.display.Loader;
  import flash.display.Sprite;
  import flash.events.Event;
  import flash.net.URLLoader;
  import flash.net.URLRequest;
  import flash.utils.setTimeout;
  
  import flashx.textLayout.compose.StandardFlowComposer;
  import flashx.textLayout.container.ContainerController;
  import flashx.textLayout.container.ScrollPolicy;
  import flashx.textLayout.conversion.ITextImporter;
  import flashx.textLayout.conversion.TextConverter;
  import flashx.textLayout.edit.EditManager;
  import flashx.textLayout.elements.Configuration;
  import flashx.textLayout.elements.TextFlow;
  import flashx.undo.UndoManager;

  public class ch18ex6 extends Sprite {
    protected var textFlow:TextFlow;
    protected var editManager:EditManager;
    public function ch18ex6() {
      var loader:URLLoader = new URLLoader(new URLRequest(
        "http://actionscriptbible.com/files/alice-ch2-tlf.xml"));
      loader.addEventListener(Event.COMPLETE, onLoadComplete);
    }
    protected function onLoadComplete(event:Event):void {
      var tlfMarkup:String = URLLoader(event.target).data;
      var flowComposer:StandardFlowComposer = new StandardFlowComposer();
      var importer:ITextImporter = 
        TextConverter.getImporter(TextConverter.TEXT_LAYOUT_FORMAT);
      importer.throwOnError = true;
      textFlow = importer.importToFlow(tlfMarkup);
      textFlow.flowComposer = flowComposer;
      
      var l:Loader = new Loader(); addChild(l);
      l.x = 10; l.y = 130;
      l.load(new URLRequest("http://actionscriptbible.com/files/alice-1.jpg"));
      
      var sprite:Sprite, container:ContainerController;
      sprite = new Sprite(); addChild(sprite);
      sprite.x = 10; sprite.y = 10; 
      container = new ContainerController(sprite, 480, 120);
      container.horizontalScrollPolicy = ScrollPolicy.OFF;
      container.verticalScrollPolicy = ScrollPolicy.OFF;
      flowComposer.addController(container);
      
      sprite = new Sprite(); addChild(sprite);
      sprite.x = 210; sprite.y = 130;
      container = new ContainerController(sprite, 280, 170)
      container.horizontalScrollPolicy = ScrollPolicy.OFF;
      container.verticalScrollPolicy = ScrollPolicy.OFF;
      flowComposer.addController(container);
      sprite = new Sprite(); addChild(sprite);
      
      sprite.x = 10; sprite.y = 310;
      container = new ContainerController(sprite, 480, 300)
      container.horizontalScrollPolicy = ScrollPolicy.OFF;
      container.verticalScrollPolicy = ScrollPolicy.OFF;
      flowComposer.addController(container);

      editManager = new EditManager(new UndoManager());
      textFlow.interactionManager = editManager;      
      textFlow.flowComposer.updateAllControllers();
      
      setTimeout(demonstrateEdits, 2000);
    }
    private function demonstrateEdits():void {
      try {
        var pointer:* = textFlow.getChildAt(0); //textFlow>_div_
        pointer = pointer.getChildAt(1); //textFlow>div>paragraph1, _paragraph2_
        editManager.selectRange(pointer.getAbsoluteStart() + 1, 40);
        editManager.applyLink("http://actionscriptbible.com");
        textFlow.flowComposer.updateAllControllers(); 
      } catch(error:Error) {
        trace("Error editing: " + error.toString());
      }
    }
  }
}