// The following code is example code from 
// "ActionScript 3.0 Bible, 2nd Edition" by Roger Braunstein
// Find all of the source code on the companion website
// http://actionscriptbible.com/
//
// Copyright (c) 2010 by Wiley Publishing, Inc., Indianapolis, Indiana
//
// Permission is hereby granted, free of charge, to any person
// obtaining a copy of this software and associated documentation
// files (the "Software"), to deal in the Software without
// restriction, including without limitation the rights to use,
// copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the
// Software is furnished to do so, subject to the following
// conditions:
//
// The above copyright notice and this permission notice shall be
// included in all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
// OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
// NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
// HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
// FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
// OTHER DEALINGS IN THE SOFTWARE.

package {
  import flash.display.Sprite;
  import flash.events.Event;
  import flash.events.KeyboardEvent;
  import flash.ui.Keyboard;

  [SWF(backgroundColor="0x000000", frameRate="4")]
  public class ch21ex11 extends Sprite {
    protected var hero:Hero;
    protected var keys:Array;
    protected const MAX_KEY:int = 128;
    public function ch21ex11() {
      stage.addEventListener(KeyboardEvent.KEY_DOWN, onKey);
      stage.addEventListener(KeyboardEvent.KEY_UP, onKey);
      keys = new Array(MAX_KEY);
      
      hero = new Hero();
      addChild(hero);
      hero.x = stage.stageWidth/2;
      hero.y = stage.stageHeight/2;
      addEventListener(Event.ENTER_FRAME, onEnterFrame);
    }
    protected function onKey(event:KeyboardEvent):void {
      if (event.keyCode >= MAX_KEY) return;
      keys[event.keyCode] = (event.type == KeyboardEvent.KEY_DOWN);
    }
    protected function onEnterFrame(event:Event):void {
      if (keys[Keyboard.UP]) hero.y -= hero.height;
      if (keys[Keyboard.DOWN]) hero.y += hero.height;
      if (keys[Keyboard.LEFT]) hero.x -= hero.width;
      if (keys[Keyboard.RIGHT]) hero.x += hero.width;
    }
  }
}
import flash.display.Shape;
class Hero extends Shape {
  public function Hero() {
    graphics.beginFill(0x10c010);
    graphics.drawRect(0, 0, 12, 30);
    graphics.endFill();
  }
}