// The following code is example code from 
// "ActionScript 3.0 Bible, 2nd Edition" by Roger Braunstein
// Find all of the source code on the companion website
// http://actionscriptbible.com/
//
// Copyright (c) 2010 by Wiley Publishing, Inc., Indianapolis, Indiana
//
// Permission is hereby granted, free of charge, to any person
// obtaining a copy of this software and associated documentation
// files (the "Software"), to deal in the Software without
// restriction, including without limitation the rights to use,
// copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the
// Software is furnished to do so, subject to the following
// conditions:
//
// The above copyright notice and this permission notice shall be
// included in all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
// OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
// NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
// HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
// FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
// OTHER DEALINGS IN THE SOFTWARE.

package {
  import flash.display.Sprite;
  import flash.events.MouseEvent;
  public class ch21ex5 extends Sprite {
    public function ch21ex5() {
      //use ROLL_OVER and ROLL_OUT on the left (red)
      var a:NestedCircles = new NestedCircles(true, 0xff0000); 
      //use MOUSE_OVER and MOUSE_OUT on the right (blue)
      var b:NestedCircles = new NestedCircles(false, 0x0000ff);
      a.x = 100;
      b.x = 250;
      a.y = b.y = 150;
      addChild(a); addChild(b);
    }
  }
}
import flash.display.*;
import flash.events.MouseEvent;
class NestedCircles extends Sprite {
  public var child:NestedCircles;
  protected var stroke:Shape;
  public function NestedCircles(useRoll:Boolean, color:uint = 0, 
                                size:Number = 60, isChild:Boolean = false) {
    graphics.beginFill(color, 0.25);
    graphics.drawCircle(0, 0, size);
    graphics.endFill();
    stroke = new Shape();
    addChild(stroke);
    stroke.graphics.lineStyle(5, 0xffff00);
    stroke.graphics.drawCircle(0, 0, size);
    stroke.visible = false;
    if (useRoll) {
      addEventListener(MouseEvent.ROLL_OVER, handler);
      addEventListener(MouseEvent.ROLL_OUT, handler);
    } else {
      addEventListener(MouseEvent.MOUSE_OVER, handler);
      addEventListener(MouseEvent.MOUSE_OUT, handler);    
    }
    if (!isChild) {
      child = new NestedCircles(useRoll, color, size/2, true);
      addChild(child);
      child.y = -size;
    }
  }
  protected function handler(event:MouseEvent):void {
    trace(event.target.name, event.type);
    switch (event.type) {
      case MouseEvent.MOUSE_OUT:
      case MouseEvent.ROLL_OUT:
        stroke.visible = false;
        event.stopPropagation();
        break;
      case MouseEvent.MOUSE_OVER:
      case MouseEvent.ROLL_OVER:
        stroke.visible = true;
        event.stopPropagation();
        break;
    }
  }
}