// The following code is example code from 
// "ActionScript 3.0 Bible, 2nd Edition" by Roger Braunstein
// Find all of the source code on the companion website
// http://actionscriptbible.com/
//
// Copyright (c) 2010 by Wiley Publishing, Inc., Indianapolis, Indiana
//
// Permission is hereby granted, free of charge, to any person
// obtaining a copy of this software and associated documentation
// files (the "Software"), to deal in the Software without
// restriction, including without limitation the rights to use,
// copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the
// Software is furnished to do so, subject to the following
// conditions:
//
// The above copyright notice and this permission notice shall be
// included in all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
// OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
// NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
// HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
// FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
// OTHER DEALINGS IN THE SOFTWARE.

package {
  import flash.display.Sprite;
  import flash.utils.Timer;

  public class ch22ex6 extends Sprite {
    public function ch22ex6()
    {
      var timer:Timer = new Timer(1000);
      var nyc:LocalClock = new LocalClock(timer, "New York City, USA", -5);
      var paris:LocalClock = new LocalClock(timer, "Paris, France", 1);
      var tokyo:LocalClock = new LocalClock(timer, "Tokyo, Japan", 10);
      addChild(nyc);
      nyc.x = 0;
      addChild(paris);
      paris.y = 50;
      addChild(tokyo);
      tokyo.y = 100;
      timer.start();
    }
  }
}

import flash.utils.Timer;
import flash.events.*;
import flash.display.Sprite;
import flash.text.*;

class LocalClock extends Sprite {
  private var location:String;
  private var timezoneOffset:int;
  private var labelTF:TextField;
  private var clockTF:TextField;
  
  public function LocalClock(timer:Timer, location:String, tzOffset:int) {
    this.location = location;
    this.timezoneOffset = tzOffset;
    labelTF = new TextField();
    clockTF = new TextField();
    labelTF.autoSize = clockTF.autoSize = TextFieldAutoSize.LEFT;
    labelTF.width = labelTF.height = clockTF.width = clockTF.height = 0;
    labelTF.selectable = clockTF.selectable = false;
    labelTF.defaultTextFormat = new TextFormat("_serif", 12, 0, false, true);
    clockTF.defaultTextFormat = new TextFormat("_typewriter", 12, 0x6AF685);
    clockTF.background = true;
    clockTF.backgroundColor = 0x000000;
    labelTF.text = location;
    clockTF.y = labelTF.textHeight + 5;
    addChild(labelTF);
    addChild(clockTF);
    timer.addEventListener(TimerEvent.TIMER, onTimer);
  }
  
  private function onTimer(event:TimerEvent = null):void {
    var date:Date = new Date();
    date.hoursUTC += timezoneOffset;
    clockTF.text = pad(date.hoursUTC) + ":"
                 + pad(date.minutesUTC) + ":"
                 + pad(date.secondsUTC);
  }
  
  private function pad(n:Number):String {
    var s:String = n.toString();
    while (s.length < 2) s = "0" + s;
    return s;
  }
}