// The following code is example code from 
// "ActionScript 3.0 Bible, 2nd Edition" by Roger Braunstein
// Find all of the source code on the companion website
// http://actionscriptbible.com/
//
// Copyright (c) 2010 by Wiley Publishing, Inc., Indianapolis, Indiana
//
// Permission is hereby granted, free of charge, to any person
// obtaining a copy of this software and associated documentation
// files (the "Software"), to deal in the Software without
// restriction, including without limitation the rights to use,
// copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the
// Software is furnished to do so, subject to the following
// conditions:
//
// The above copyright notice and this permission notice shall be
// included in all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
// OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
// NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
// HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
// FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
// OTHER DEALINGS IN THE SOFTWARE.

package {
  import flash.display.*;
  import flash.events.*;
  import flash.net.URLRequest;
  import flash.text.*;
  import flash.utils.describeType;

  public class ch27ex2 extends Sprite {
    protected var preloadTF:TextField;
    protected var l:Loader;
    public function ch27ex2() {
      l = new Loader();
      //photo   (CC-BY) Roger Braunstein
      //source  http://www.flickr.com/photos/rogerimp/2940373537/
      var url:String = "http://actionscriptbible.com/files/heiwadoori.jpg";
      l.load(new URLRequest(url));
      
      //this textfield will show the progress of the loading process.
      preloadTF = new TextField();
      preloadTF.defaultTextFormat = new TextFormat("_sans", 12, 0);
      preloadTF.autoSize = TextFieldAutoSize.LEFT;
      addChild(preloadTF);
      
      l.contentLoaderInfo.addEventListener(Event.COMPLETE, onComplete);
      l.contentLoaderInfo.addEventListener(ProgressEvent.PROGRESS, onProgress);
      l.contentLoaderInfo.addEventListener(IOErrorEvent.IO_ERROR, onError);
    }
    
    protected function onComplete(event:Event):void {
      var info:LoaderInfo = LoaderInfo(event.target);
      preloadTF.text = "loaded " + info.width + "x" + info.height + " " + 
        (info.bytesTotal>>10) + "kb" + " image of type " + info.contentType;
      l.y = preloadTF.textHeight + 4;
      addChild(l);
      trace(describeType(l.content));
    }
    
    protected function onProgress(event:ProgressEvent):void {
      var percent:Number = event.bytesLoaded / event.bytesTotal * 100;
      preloadTF.text = percent.toFixed() + "%";
    }
    
    protected function onError(event:ErrorEvent):void {
      preloadTF.text = event.text;
    }
  }
}