// The following code is example code from 
// "ActionScript 3.0 Bible, 2nd Edition" by Roger Braunstein
// Find all of the source code on the companion website
// http://actionscriptbible.com/
//
// Copyright (c) 2010 by Wiley Publishing, Inc., Indianapolis, Indiana
//
// Permission is hereby granted, free of charge, to any person
// obtaining a copy of this software and associated documentation
// files (the "Software"), to deal in the Software without
// restriction, including without limitation the rights to use,
// copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the
// Software is furnished to do so, subject to the following
// conditions:
//
// The above copyright notice and this permission notice shall be
// included in all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
// OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
// NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
// HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
// FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
// OTHER DEALINGS IN THE SOFTWARE.

package {
  import com.actionscriptbible.Example;
  import flash.net.SharedObject;
  import flash.net.registerClassAlias;

  public class ch29ex3 extends Example {
    protected var currentPage:int;
    protected var so:SharedObject;
    
    public function ch29ex3() {
      registerClassAlias("Bookmark", Bookmark);
      so = SharedObject.getLocal("storage");
      if (so.data.bookmark) {
        //go to the stored bookmark
        var b:Bookmark = Bookmark(so.data.bookmark);
        trace("found", b);
        gotoPage(b.page);
        
        //read the next page and bookmark it
        trace("advancing a page...");
        gotoPage(currentPage + 1);
        setBookmark();
      } else {
        //start at the first page if there's no bookmark
        gotoPage(1);
        setBookmark();
      }
    }
    
    public function setBookmark():void {
      var b:Bookmark = new Bookmark();
      b.page = currentPage;
      so.data.bookmark = b;
      trace("setting", so.data.bookmark);
    }
    
    public function gotoPage(page:int):void {
      trace("going to page", page);
      currentPage = page;
    }
  }
}

class Bookmark {
  public var page:int;
  
  public function Bookmark() {
  }
  
  public function toString():String {
    return "[Bookmark at page " + page + "]";
  }
}