// The following code is example code from 
// "ActionScript 3.0 Bible, 2nd Edition" by Roger Braunstein
// Find all of the source code on the companion website
// http://actionscriptbible.com/
//
// Copyright (c) 2010 by Wiley Publishing, Inc., Indianapolis, Indiana
//
// Permission is hereby granted, free of charge, to any person
// obtaining a copy of this software and associated documentation
// files (the "Software"), to deal in the Software without
// restriction, including without limitation the rights to use,
// copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the
// Software is furnished to do so, subject to the following
// conditions:
//
// The above copyright notice and this permission notice shall be
// included in all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
// OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
// NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
// HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
// FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
// OTHER DEALINGS IN THE SOFTWARE.

package {
  import com.actionscriptbible.Example;
  import flash.events.MouseEvent;
  import flash.media.*;
  import flash.net.URLRequest;

  public class ch31ex2 extends Example {
    protected var activeSound:SoundChannel;
    protected var winterSong:Sound;
    public function ch31ex2() {
      //The Four Seasons: Winter [performance & recording in the public domain]
      //composed by Antonio Vivaldi, performed by the US Air Force Band
      winterSong = new Sound();
      winterSong.load(
        new URLRequest("http://actionscriptbible.com/files/winter.mp3"),
        new SoundLoaderContext(5000, true)
      );
      stage.addEventListener(MouseEvent.CLICK, onClick);
      activeSound = winterSong.play();
      trace("Playing song...");
    }
    protected function onClick(event:MouseEvent):void {
      if (activeSound) {
        activeSound.stop(); //it's that easy
        activeSound = null;
        trace("Stopped!");
      }
    }
  }
}