// The following code is example code from 
// "ActionScript 3.0 Bible, 2nd Edition" by Roger Braunstein
// Find all of the source code on the companion website
// http://actionscriptbible.com/
//
// Copyright (c) 2010 by Wiley Publishing, Inc., Indianapolis, Indiana
//
// Permission is hereby granted, free of charge, to any person
// obtaining a copy of this software and associated documentation
// files (the "Software"), to deal in the Software without
// restriction, including without limitation the rights to use,
// copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the
// Software is furnished to do so, subject to the following
// conditions:
//
// The above copyright notice and this permission notice shall be
// included in all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
// OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
// NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
// HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
// FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
// OTHER DEALINGS IN THE SOFTWARE.

package {
  import flash.display.Sprite;
  import flash.net.URLRequest;
  import flash.events.*;
  import flash.media.*;
  import flash.text.*;
  public class ch31ex3 extends Sprite {
    protected var sound:Sound;
    protected var channel:SoundChannel;
    protected var lastPosition:Number;
    protected var positionTF:TextField;
    protected var isPaused:Boolean = false;
    protected const SEARCH_RATE:int = 2000;
    public function ch31ex3() {
      createChildren();
      var songurl:String = "http://actionscriptbible.com/files/winter.mp3";
      sound = new Sound(new URLRequest(songurl));
      play();
    }
    protected function createChildren():void {
      var txtFormat:TextFormat = new TextFormat("_typewriter", 14, 0);
      var controlsTF:TextField = new TextField();
      controlsTF.defaultTextFormat = txtFormat;
      controlsTF.selectable = false;
      controlsTF.htmlText = '<a href="event:rw">&lt;&lt;</a>\t' +
        '<a href="event:pause">||</a>\t<a href="event:ff">&gt;&gt;</a>';
      controlsTF.addEventListener(TextEvent.LINK, onControlClicked);
      addChild(controlsTF);
      positionTF = new TextField();
      positionTF.defaultTextFormat = txtFormat;
      positionTF.x = controlsTF.textWidth + 15;
      addChild(positionTF);
      this.addEventListener(Event.ENTER_FRAME, updatePositionDisplay);
    }
    public function play(position:int = 0):void {
      if (channel) channel.stop();
      channel = sound.play(position);
    }
    public function rewind(event:Event = null):void {
      if (!channel) return;
      isPaused = false;
      lastPosition = channel.position - SEARCH_RATE;
      lastPosition = Math.max(0, lastPosition);
      play(lastPosition);
    }
    public function fastForward():void {
      if (!channel) return;
      isPaused = false;
      lastPosition = channel.position + SEARCH_RATE;
      lastPosition = Math.min(sound.length, lastPosition);
      play(lastPosition);
    }
    public function pause():void {
      lastPosition = channel.position;
      channel.stop();
    }
    public function resume():void {
      play(lastPosition);
    }
    protected function updatePositionDisplay(event:Event):void {
      if (channel && sound) {
        positionTF.text = (channel.position/1000).toFixed(2) + " / " +
                          (sound.length/1000).toFixed();
      }
    }
    protected function onControlClicked(event:TextEvent):void {
      switch (event.text) {
        case "pause":
          (isPaused)? resume() : pause();
          isPaused = !isPaused;
          break;
        case "rw": rewind(); break;
        case "ff": fastForward(); break;
      }
    }
  }
}