// The following code is example code from 
// "ActionScript 3.0 Bible, 2nd Edition" by Roger Braunstein
// Find all of the source code on the companion website
// http://actionscriptbible.com/
//
// Copyright (c) 2010 by Wiley Publishing, Inc., Indianapolis, Indiana
//
// Permission is hereby granted, free of charge, to any person
// obtaining a copy of this software and associated documentation
// files (the "Software"), to deal in the Software without
// restriction, including without limitation the rights to use,
// copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the
// Software is furnished to do so, subject to the following
// conditions:
//
// The above copyright notice and this permission notice shall be
// included in all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
// OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
// NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
// HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
// FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
// OTHER DEALINGS IN THE SOFTWARE.

package {
  import com.actionscriptbible.Example;
  
  import flash.geom.Vector3D;

  public class ch34ex4 extends Example{
    public function ch34ex4() {
      var v:Vector3D = new Vector3D(8, 4, 1);
      trace(v.length); //9
      trace(v.lengthSquared); //81
      
      var a:Vector3D, b:Vector3D, c:Vector3D;
      a = new Vector3D(12, 47, 209);
      trace(a.dotProduct(Vector3D.X_AXIS)); //12
      
      a = new Vector3D(12, 0, 0); //points along +x
      b = new Vector3D(0, 12, 0); //points along +y
      c = a.crossProduct(b); //should point along +z, perpendicular to both
      trace(c); //Vector3D(0, 0, 144)

      c.normalize();
      trace(c, c.length); //Vector3D(0, 0, 1) 1
      
      trace(Vector3D.angleBetween(Vector3D.X_AXIS, new Vector3D(1, 1))/Math.PI);
    }
  }
}