// The following code is example code from 
// "ActionScript 3.0 Bible, 2nd Edition" by Roger Braunstein
// Find all of the source code on the companion website
// http://actionscriptbible.com/
//
// Copyright (c) 2010 by Wiley Publishing, Inc., Indianapolis, Indiana
//
// Permission is hereby granted, free of charge, to any person
// obtaining a copy of this software and associated documentation
// files (the "Software"), to deal in the Software without
// restriction, including without limitation the rights to use,
// copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the
// Software is furnished to do so, subject to the following
// conditions:
//
// The above copyright notice and this permission notice shall be
// included in all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
// OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
// NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
// HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
// FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
// OTHER DEALINGS IN THE SOFTWARE.

package {
  import com.actionscriptbible.Example;
  import flash.geom.Matrix3D;
  
  public class ch34ex5 extends Example {
    public function ch34ex5() {
      //create a default (identity) matrix
      var m:Matrix3D = new Matrix3D();
      prettyPrintMatrix(m); //identity matrix

      var v:Vector.<Number> = m.rawData;
      v[4] = 9.2;
      m.rawData = v;
      prettyPrintMatrix(m); //9.2 appears on top of 2nd column

      m.identity(); //reset matrix
      m.appendTranslation(16, 19, 21);
      prettyPrintMatrix(m); //the translation factors appear in column 4
    }
    protected function prettyPrintMatrix(m:Matrix3D):void {
      var str:String = "";
      for (var col:int = 0; col < 4; col++) {
        var line:String = "|";
        for (var row:int = 0; row < 4; row++) {
          line += "\t" + m.rawData[row*4+col].toPrecision(3) + "\t";
        }
        str += line + "|\n";
      }
      trace(str);
    }
  }
}