// The following code is example code from 
// "ActionScript 3.0 Bible, 2nd Edition" by Roger Braunstein
// Find all of the source code on the companion website
// http://actionscriptbible.com/
//
// Copyright (c) 2010 by Wiley Publishing, Inc., Indianapolis, Indiana
//
// Permission is hereby granted, free of charge, to any person
// obtaining a copy of this software and associated documentation
// files (the "Software"), to deal in the Software without
// restriction, including without limitation the rights to use,
// copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the
// Software is furnished to do so, subject to the following
// conditions:
//
// The above copyright notice and this permission notice shall be
// included in all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
// OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
// NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
// HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
// FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
// OTHER DEALINGS IN THE SOFTWARE.

package {
  import flash.display.*;
  import flash.events.MouseEvent;
  
  public class ch35ex18 extends Sprite {
    protected const NUM_COPIES:int = 6;
    public function ch35ex18() {
      for (var i:int = 0; i < NUM_COPIES; i++) {
        var copy:Shape = new Shape();
        copy.graphics.lineStyle(8, 0xE91C7A, 0.3, false);
        copy.rotationY = 70;
        copy.rotationZ = i * (360 / NUM_COPIES);
        copy.x = stage.stageWidth / 2;
        copy.y = stage.stageHeight / 2;
        addChild(copy);
      }
      stage.addEventListener(MouseEvent.MOUSE_MOVE, onMouseMove);
    }
    protected function onMouseMove(event:MouseEvent):void {
      var source:Shape = Shape(getChildAt(0));
      source.graphics.lineTo(stage.mouseX - stage.stageWidth/2,
                             stage.mouseY - stage.stageHeight/2);
      for (var i:int = 1; i < NUM_COPIES; i++) {
        var copy:Shape = getChildAt(i) as Shape;
        copy.graphics.copyFrom(source.graphics);
      }
    }
  }
}