// The following code is example code from 
// "ActionScript 3.0 Bible, 2nd Edition" by Roger Braunstein
// Find all of the source code on the companion website
// http://actionscriptbible.com/
//
// Copyright (c) 2010 by Wiley Publishing, Inc., Indianapolis, Indiana
//
// Permission is hereby granted, free of charge, to any person
// obtaining a copy of this software and associated documentation
// files (the "Software"), to deal in the Software without
// restriction, including without limitation the rights to use,
// copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the
// Software is furnished to do so, subject to the following
// conditions:
//
// The above copyright notice and this permission notice shall be
// included in all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
// OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
// NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
// HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
// FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
// OTHER DEALINGS IN THE SOFTWARE.

package {
  import flash.display.*;
  import flash.events.Event;
  import flash.geom.Point;
  import flash.media.Camera;
  import flash.media.Video;
  public class ch36ex11 extends Sprite {
    protected var bmp:BitmapData;
    protected var thresholdBmp:BitmapData;
    protected var video:Video;
    public function ch36ex11() {
      bmp = new BitmapData(400, 300);
      addChild(new Bitmap(bmp));
      video = new Video(400, 300);
      video.attachCamera(Camera.getCamera());
      stage.addEventListener(Event.ENTER_FRAME, onEnterFrame);
    }
    protected function onEnterFrame(event:Event):void {
      bmp.draw(video);
      var hst:Vector.<Vector.<Number>> = bmp.histogram(bmp.rect);
      var maxValue:Vector.<int> = new Vector.<int>(3, true);
      var maxFrequency:Vector.<Number> = new Vector.<Number>(3, true);
      for (var channel:int = 0; channel < 3; channel++) {
        for (var i:int = 0; i < 256; i++) {
          var value:Number = hst[channel][i];
          if (value > maxFrequency[channel]) {
            maxFrequency[channel] = value;
            maxValue[channel] = i;
          }
        }
      }
      var threshold:uint = maxValue[0] << 16 | maxValue[1] << 8 | maxValue[2];
      bmp.threshold(bmp, bmp.rect, new Point(),
        ">", threshold, 0xff000000, 0x00ffffff, true);
    }
  }
}