// The following code is example code from 
// "ActionScript 3.0 Bible, 2nd Edition" by Roger Braunstein
// Find all of the source code on the companion website
// http://actionscriptbible.com/
//
// Copyright (c) 2010 by Wiley Publishing, Inc., Indianapolis, Indiana
//
// Permission is hereby granted, free of charge, to any person
// obtaining a copy of this software and associated documentation
// files (the "Software"), to deal in the Software without
// restriction, including without limitation the rights to use,
// copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the
// Software is furnished to do so, subject to the following
// conditions:
//
// The above copyright notice and this permission notice shall be
// included in all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
// OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
// NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
// HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
// FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
// OTHER DEALINGS IN THE SOFTWARE.

package {
  import flash.display.*;
  import flash.events.*;
  import flash.geom.Point;
  import flash.media.Video;
  import flash.net.*;
  import flash.system.Security;
  import flash.text.*;
  public class ch36ex12 extends Sprite {
    protected var RLUT:Array, GLUT:Array, BLUT:Array;
    protected var video:Video;
    protected var bmp:BitmapData;
    protected var tf:TextField;
    public function ch36ex12() {
      RLUT = new Array(256);
      GLUT = new Array(256);
      BLUT = new Array(256);
      var nc:NetConnection = new NetConnection();
      nc.connect(null);
      var ns:NetStream = new NetStream(nc);
      ns.play("http://actionscriptbible.com/files/bullettrain.mp4");
      ns.client = new Object();
      video = new Video();
      video.attachNetStream(ns);
      video.scaleX = video.scaleY = 0.5;
      bmp = new BitmapData(320, 240);
      addChild(new Bitmap(bmp));
      video.addEventListener(Event.ENTER_FRAME, onEnterFrame);
      stage.addEventListener(MouseEvent.MOUSE_MOVE, onMouseMove);
      tf = new TextField(); tf.width = 26; tf.height = 14; tf.x = tf.y = 5;
      tf.backgroundColor = 0; tf.background = true;
      tf.defaultTextFormat = new TextFormat("_typewriter", 10, 0xffffff);
      addChild(tf);
    }
    protected function onEnterFrame(event:Event):void {
        bmp.draw(video);
        bmp.paletteMap(bmp, bmp.rect, new Point(), RLUT, GLUT, BLUT);
    }
    protected function onMouseMove(event:MouseEvent):void {
      var newGamma:Number = (1 - stage.mouseY / stage.stageHeight) * 2.5;
      tf.text = newGamma.toFixed(1);
      for (var v:int = 0; v < 256; v++) {
        BLUT[v] = int(Math.pow(v / 256.0, newGamma) * 256);
        GLUT[v] = BLUT[v] << 8;
        RLUT[v] = GLUT[v] << 8;
      }
    }
  }
}