// The following code is example code from 
// "ActionScript 3.0 Bible, 2nd Edition" by Roger Braunstein
// Find all of the source code on the companion website
// http://actionscriptbible.com/
//
// Copyright (c) 2010 by Wiley Publishing, Inc., Indianapolis, Indiana
//
// Permission is hereby granted, free of charge, to any person
// obtaining a copy of this software and associated documentation
// files (the "Software"), to deal in the Software without
// restriction, including without limitation the rights to use,
// copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the
// Software is furnished to do so, subject to the following
// conditions:
//
// The above copyright notice and this permission notice shall be
// included in all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
// OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
// NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
// HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
// FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
// OTHER DEALINGS IN THE SOFTWARE.

package {
  import flash.display.*;
  import flash.events.Event;
  import flash.filters.BlurFilter;
  import flash.geom.Point;
  import flash.net.URLRequest;
  import flash.system.LoaderContext;
  [SWF(frameRate="24", backgroundColor="#000000")]
  public class ch36ex14 extends Sprite {
    protected var bmp:BitmapData;
    protected var seed:int;
    protected var image:Loader;
    public function ch36ex14() {
      image = new Loader();
      addChild(image);
      image.contentLoaderInfo.addEventListener(Event.COMPLETE, onLoad);
      image.load(
        new URLRequest("http://actionscriptbible.com/files/caviar.jpg"),
        new LoaderContext(true)
      );
    }
    protected function onLoad(event:Event):void {
      var src:BitmapData = Bitmap(image.content).bitmapData;
      bmp = new BitmapData(src.width, src.height, true);
      var bitmap:Bitmap = new Bitmap(bmp);
      addChild(bitmap);
      bitmap.blendMode = BlendMode.MULTIPLY;
      addEventListener(Event.ENTER_FRAME, onEnterFrame);
    }
    protected function onEnterFrame(event:Event):void {
      bmp.fillRect(bmp.rect, 0);
      bmp.noise(++seed, 200, 255, BitmapDataChannel.BLUE, true);
      bmp.applyFilter(bmp, bmp.rect, new Point(), new BlurFilter(4, 4, 2));
      image.alpha = (seed % 2)? 0.95 : 1;
    }
  }
}