// The following code is example code from 
// "ActionScript 3.0 Bible, 2nd Edition" by Roger Braunstein
// Find all of the source code on the companion website
// http://actionscriptbible.com/
//
// Copyright (c) 2010 by Wiley Publishing, Inc., Indianapolis, Indiana
//
// Permission is hereby granted, free of charge, to any person
// obtaining a copy of this software and associated documentation
// files (the "Software"), to deal in the Software without
// restriction, including without limitation the rights to use,
// copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the
// Software is furnished to do so, subject to the following
// conditions:
//
// The above copyright notice and this permission notice shall be
// included in all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
// OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
// NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
// HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
// FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
// OTHER DEALINGS IN THE SOFTWARE.

package {
  import flash.display.*;
  import flash.geom.*;
  import flash.events.MouseEvent;
  public class ch36ex6 extends Sprite {
    protected const AVG_RADIUS:Number = 30;
    protected var bmp:BitmapData;
    public function ch36ex6() {
      bmp = new BitmapData(stage.stageWidth, stage.stageHeight);
      var bitmap:Bitmap = new Bitmap(bmp);
      addChild(bitmap);
      stage.addEventListener(MouseEvent.CLICK, onClick);
    }
    protected function onClick(event:MouseEvent):void {
      bmp.lock();
      var radius:Number = (Math.random() - 0.5) * AVG_RADIUS + AVG_RADIUS;
      var center:Point = new Point(event.localX, event.localY);
      var bounds:Rectangle = new Rectangle(center.x, center.y, 0, 0);
      bounds.inflate(2*radius, 2*radius);
      bounds = bounds.intersection(bmp.rect);
      var p:Point = new Point();
      for (p.y = int(bounds.top); p.y < bounds.bottom; p.y++) {
        for (p.x = int(bounds.left); p.x < bounds.right; p.x++) {
          var dist:Number = Point.distance(p, center);
          if (dist < radius) {
            var alpha:uint = 0xff * (1 - dist / radius);
            bmp.setPixel32(p.x, p.y, alpha << 24);
          }
        }
      }
      bmp.unlock(bounds);
    }
  }
}