// The following code is example code from 
// "ActionScript 3.0 Bible, 2nd Edition" by Roger Braunstein
// Find all of the source code on the companion website
// http://actionscriptbible.com/
//
// Copyright (c) 2010 by Wiley Publishing, Inc., Indianapolis, Indiana
//
// Permission is hereby granted, free of charge, to any person
// obtaining a copy of this software and associated documentation
// files (the "Software"), to deal in the Software without
// restriction, including without limitation the rights to use,
// copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the
// Software is furnished to do so, subject to the following
// conditions:
//
// The above copyright notice and this permission notice shall be
// included in all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
// OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
// NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
// HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
// FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
// OTHER DEALINGS IN THE SOFTWARE.

package {
  import flash.display.*;
  import flash.events.Event;
  import flash.net.URLRequest;
  import flash.system.LoaderContext;
  import flash.utils.ByteArray;
  [SWF(backgroundColor="#000000")]
  public class ch36ex7 extends Sprite {
    public function ch36ex7() {
      var l:Loader = new Loader();
      l.load(
        new URLRequest("http://actionscriptbible.com/files/testpattern.png"),
        new LoaderContext(true)
      );
      l.contentLoaderInfo.addEventListener(Event.COMPLETE, onLoad);
    }
    protected function onLoad(event:Event):void {
      var src:BitmapData = Bitmap(LoaderInfo(event.target).content).bitmapData;
      //setting the alpha channel doesn't work if the image isn't transparent
      //so we copy the bitmap data into a new transparent BitmapData
      var bmp:BitmapData = new BitmapData(src.width, src.height, true);
      bmp.draw(src);
      var bytes:ByteArray = bmp.getPixels(bmp.rect);
      for (var y:int = 0; y < bmp.height; y+=2) {
        for (var x:int = 0; x < bmp.width; x++) {
          //find the alpha channel of x,y
          bytes[y * bmp.width * 4 + x * 4] = 0x0;
        }
      }
      //you must rewind the ByteArray first, for some reason
      bytes.position = 0;
      bmp.setPixels(bmp.rect, bytes);
      var bitmap:Bitmap = new Bitmap(bmp);
      addChild(bitmap);
    }
  }
}