// The following code is example code from 
// "ActionScript 3.0 Bible, 2nd Edition" by Roger Braunstein
// Find all of the source code on the companion website
// http://actionscriptbible.com/
//
// Copyright (c) 2010 by Wiley Publishing, Inc., Indianapolis, Indiana
//
// Permission is hereby granted, free of charge, to any person
// obtaining a copy of this software and associated documentation
// files (the "Software"), to deal in the Software without
// restriction, including without limitation the rights to use,
// copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the
// Software is furnished to do so, subject to the following
// conditions:
//
// The above copyright notice and this permission notice shall be
// included in all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
// OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
// NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
// HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
// FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
// OTHER DEALINGS IN THE SOFTWARE.

package {
  import flash.display.Sprite;
  import flash.filters.ConvolutionFilter;

  public class ch37ex12 extends Sprite {
    function ch37ex12() {
      var a:TestImage = new TestImage(0.5, 0, 0);
      var b:TestImage = new TestImage(0.5, 250, 0);
      var c:TestImage = new TestImage(0.5, 0, 167);
      var d:TestImage = new TestImage(0.5, 250, 167);
      addChild(a);
      addChild(b);
      addChild(c);
      addChild(d);
      var aMat:Array = [0,  1, 0,
                        1, -4, 1,
                        0,  1, 0]; //edge detect
      a.filters = [new ConvolutionFilter(3, 3, aMat)];
      var bMat:Array = [ 0, -1,  0,
                        -1,  5, -1,
                         0, -1,  0]; //sharpen
      b.filters = [new ConvolutionFilter(3, 3, bMat)];
      var cMat:Array = [1, 1, 1,
                        1, 1, 1,
                        1, 1, 1]; //blur
      c.filters = [new ConvolutionFilter(3, 3, cMat, 9)];
      var dMat:Array = [-2, -1, 0,
                        -1,  1, 1,
                         0,  1, 2]; //emboss
      d.filters = [new ConvolutionFilter(3, 3, dMat)];
                        
    }
  }
}
import flash.display.Loader;
import flash.net.URLRequest;
import flash.system.LoaderContext;
import flash.events.MouseEvent;
import flash.geom.Point;
class TestImage extends Loader {
  protected var scale:Number;
  protected var origin:Point;
  public function TestImage(scale:Number = 1, x:Number = 0, y:Number = 0) {
    //photo   (CC-BY) Roger Braunstein
    //source  http://www.flickr.com/photos/rogerimp/2940373537/
    var url:String = "http://actionscriptbible.com/files/heiwadoori.jpg";
    load(new URLRequest(url), new LoaderContext(true));
    this.scale = scale;
    this.origin = new Point(x, y);
    addEventListener(MouseEvent.MOUSE_DOWN, onMouseDown);
    addEventListener(MouseEvent.MOUSE_UP, onMouseUp);
    onMouseUp(null);
  }
  protected function onMouseDown(event:MouseEvent):void {
    parent.setChildIndex(this, parent.numChildren-1);
    scaleX = scaleY = 1;
    x = y = 0;
  }
  protected function onMouseUp(event:MouseEvent):void {
    scaleX = scaleY = scale;
    x = origin.x; y = origin.y;
  }
}