// The following code is example code from 
// "ActionScript 3.0 Bible, 2nd Edition" by Roger Braunstein
// Find all of the source code on the companion website
// http://actionscriptbible.com/
//
// Copyright (c) 2010 by Wiley Publishing, Inc., Indianapolis, Indiana
//
// Permission is hereby granted, free of charge, to any person
// obtaining a copy of this software and associated documentation
// files (the "Software"), to deal in the Software without
// restriction, including without limitation the rights to use,
// copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the
// Software is furnished to do so, subject to the following
// conditions:
//
// The above copyright notice and this permission notice shall be
// included in all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
// OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
// NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
// HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
// FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
// OTHER DEALINGS IN THE SOFTWARE.

package {
  import flash.display.*;
  import flash.events.*;
  import flash.filters.*;
  import flash.media.*;
  import flash.net.*;
  import flash.utils.ByteArray;
  
  public class ch38ex1 extends Sprite {
    protected var camVideo:Video;
    protected var shader:Shader;
    protected var shaderFilter:ShaderFilter;
    public function ch38ex1() {
      camVideo = new Video(stage.stageWidth, stage.stageHeight);
      camVideo.attachCamera(Camera.getCamera());
      addChild(camVideo);
      
      var PBJURL:String = "http://actionscriptbible.com/files/circle2.pbj";
      var loader:URLLoader = new URLLoader(new URLRequest(PBJURL));
      loader.dataFormat = URLLoaderDataFormat.BINARY;
      loader.addEventListener(Event.COMPLETE, onBytecodeLoaded);
    }
    protected function onBytecodeLoaded(event:Event):void {
      var loader:URLLoader = URLLoader(event.target);
      loader.removeEventListener(Event.COMPLETE, onBytecodeLoaded);
      shader = new Shader(ByteArray(loader.data));
      shaderFilter = new ShaderFilter(shader);
      stage.addEventListener(Event.ENTER_FRAME, onEnterFrame);
      stage.addEventListener(MouseEvent.MOUSE_WHEEL, onMouseWheel)
    }
    protected function onEnterFrame(event:Event):void {
      shader.data.circleCenter.value = [stage.mouseX, stage.mouseY];
      camVideo.filters = [shaderFilter]; //update the filter
    }
    protected function onMouseWheel(event:MouseEvent):void {
      shader.data.circleRadius.value[0] += 3 * event.delta;
    }
  }
}