// The following code is example code from 
// "ActionScript 3.0 Bible, 2nd Edition" by Roger Braunstein
// Find all of the source code on the companion website
// http://actionscriptbible.com/
//
// Copyright (c) 2010 by Wiley Publishing, Inc., Indianapolis, Indiana
//
// Permission is hereby granted, free of charge, to any person
// obtaining a copy of this software and associated documentation
// files (the "Software"), to deal in the Software without
// restriction, including without limitation the rights to use,
// copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the
// Software is furnished to do so, subject to the following
// conditions:
//
// The above copyright notice and this permission notice shall be
// included in all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
// OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
// NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
// HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
// FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
// OTHER DEALINGS IN THE SOFTWARE.

package {
  import com.actionscriptbible.Example;
  import flash.globalization.*;
  public class ch41ex4 extends Example {
    public function ch41ex4() {
      var local:CurrencyFormatter = new CurrencyFormatter(LocaleID.DEFAULT);
      trace(local.format(123456.78)); //USD123,456.78
      var usa:CurrencyFormatter = new CurrencyFormatter("en-US");
      trace(usa.format(123456.78, true)); //$123,456.78
      var jp:CurrencyFormatter = new CurrencyFormatter("ja-JP");
      trace(jp.format(123456.78, true)); //¥123,457
      var de:CurrencyFormatter = new CurrencyFormatter("de-DE");
      trace (de.format(123456.78, true)); //123.456,78 €
      var fr:CurrencyFormatter = new CurrencyFormatter("fr-FR");
      trace (fr.format(123456.78, true)); //123 456,78 €
      
      var localeID:LocaleID = new LocaleID(local.actualLocaleIDName);
      trace("Local currency in " + localeID.getRegion() + ": " +
        local.currencyISOCode + " (" + local.currencySymbol + ")");
    }
  }
}