// The following code is example code from 
// "ActionScript 3.0 Bible, 2nd Edition" by Roger Braunstein
// Find all of the source code on the companion website
// http://actionscriptbible.com/
//
// Copyright (c) 2010 by Wiley Publishing, Inc., Indianapolis, Indiana
//
// Permission is hereby granted, free of charge, to any person
// obtaining a copy of this software and associated documentation
// files (the "Software"), to deal in the Software without
// restriction, including without limitation the rights to use,
// copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the
// Software is furnished to do so, subject to the following
// conditions:
//
// The above copyright notice and this permission notice shall be
// included in all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
// OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
// NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
// HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
// FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
// OTHER DEALINGS IN THE SOFTWARE.

package {
  import flash.display.Shape;
  import flash.display.Sprite;
  import flash.events.TimerEvent;
  import flash.external.ExternalInterface;
  import flash.utils.Timer;

  [SWF(width="550", height="400", backgroundColor="#eeeeee")]
  public class ch43ex2 extends Sprite {
    private var rectangle:Shape;
    private var timer:Timer;
    public function ch43ex2() {
      rectangle = new Shape();
      rectangle.graphics.lineStyle(5, 0, 1);
      rectangle.graphics.drawRect(0, 10, 100, 100);
      addChild(rectangle);
      timer = new Timer(50);
      timer.addEventListener(TimerEvent.TIMER, timerHandler);
      togglePlayback();
      if (ExternalInterface.available) {
        ExternalInterface.addCallback("togglePlayback", togglePlayback);
      }
    }
    public function togglePlayback():void {
      if (timer.running) {
        timer.stop();
      } else {
        timer.start();
      }
    }
    private function timerHandler(event:TimerEvent):void {
      if (stage) {
        rectangle.x += 5;
        if (rectangle.x > stage.stageWidth) {
          rectangle.x = 0;
        }
      }
    }
  }
}
