// The following code is example code from 
// "ActionScript 3.0 Bible, 2nd Edition" by Roger Braunstein
// Find all of the source code on the companion website
// http://actionscriptbible.com/
//
// Copyright (c) 2010 by Wiley Publishing, Inc., Indianapolis, Indiana
//
// Permission is hereby granted, free of charge, to any person
// obtaining a copy of this software and associated documentation
// files (the "Software"), to deal in the Software without
// restriction, including without limitation the rights to use,
// copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the
// Software is furnished to do so, subject to the following
// conditions:
//
// The above copyright notice and this permission notice shall be
// included in all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
// OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
// NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
// HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
// FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
// OTHER DEALINGS IN THE SOFTWARE.

package {
  import com.actionscriptbible.Example;
  public class ch8ex6 extends Example {
    protected var bookshelf:Array;
    
    public function ch8ex6() {
      bookshelf = new Array();
      bookshelf.push(new Book("Jonathan Strange & Mr Norrell",
        "Susanna Clarke", 2006));
      bookshelf.push(new Book("Anathem", "Neal Stephenson", 2008));
      bookshelf.push(new Book("VALIS", "Philip K. Dick", 1991));
      bookshelf.push(new Book("The Crystal World", "J.G. Ballard", 1966));
      
      trace("---- default sort");
      bookshelf.sort();
      traceBookshelf();
      
      var byDate:Function = function(a:Book, b:Book):Number {
        if (a.year == b.year) return 0;
        else if (a.year < b.year) return -1;
        else return 1;
      }
      
      trace("---- sorted by date");
      bookshelf.sort(byDate);
      traceBookshelf();

      trace("---- by date numerically, descending");
      bookshelf.sort(byDate, Array.NUMERIC | Array.DESCENDING);
      traceBookshelf();     

      trace("---- by date using sortOn");
      bookshelf.sortOn(["year"], Array.NUMERIC);
      traceBookshelf();
      
      trace("---- by author using sortOn");
      bookshelf.sortOn(["author"], Array.CASEINSENSITIVE);
      traceBookshelf();
    }
    
    protected function traceBookshelf():void {
      trace(bookshelf.join("\n"));
    }
  }
  
}
class Book {
  public var title:String;
  public var author:String;
  public var year:int;

  public function Book (title:String, author:String, year:int) {
    this.title = title;
    this.author = author;
    this.year = year;
  }
  
  public function toString():String {
    return '"' + title + '", ' + author + ' (' + year + ')';
  }
}
