// The following code is example code from 
// "ActionScript 3.0 Bible, 2nd Edition" by Roger Braunstein
// Find all of the source code on the companion website
// http://actionscriptbible.com/
//
// Copyright (c) 2010 by Wiley Publishing, Inc., Indianapolis, Indiana
//
// Permission is hereby granted, free of charge, to any person
// obtaining a copy of this software and associated documentation
// files (the "Software"), to deal in the Software without
// restriction, including without limitation the rights to use,
// copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the
// Software is furnished to do so, subject to the following
// conditions:
//
// The above copyright notice and this permission notice shall be
// included in all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
// OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
// NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
// HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
// FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
// OTHER DEALINGS IN THE SOFTWARE.

package {
  import com.actionscriptbible.Example;
  public class ch9ex1 extends Example {
    protected var peopleVector:Vector.<Person>;
    protected const roger:Person = new Person("Roger");
    protected const sabrina:Person = new Person("Sabrina");
    protected const tawnie:Person = new Person("Tawnie");
    protected const usman:Person = new Person("Usman");
    protected const victoria:Person = new Person("Victoria");
    
    public function ch9ex1() {
      peopleVector = new Vector.<Person>();
      peopleVector.push(roger, sabrina, tawnie, usman, victoria);
      for each (var person:Person in peopleVector) {
        roger.addFriendSymmetric(person);
      }
      sabrina.addFriendSymmetric(tawnie);
      var tawniesFriend:Person = new Person("Mary Alice");
      tawnie.addFriendSymmetric(tawniesFriend);
      var nixon:Person = new Person("Richard Nixon");
      
      trace("is Mary Alice connected to Victoria?");
      trace(tawniesFriend.isConnectedTo(victoria)); //true
      //Mary Alice -> Tawnie -> Roger -> Victoria
      trace("is Roger connected to Richard Nixon?");
      trace(roger.isConnectedTo(nixon)); //false
    }
  }
}

import flash.utils.Dictionary;
class Person {
  public var name:String;
  private var friends:Vector.<Person>;
  
  public function Person(name:String) {
    this.name = name;
    friends = new Vector.<Person>();
  }
  public function addFriend(newFriend:Person):void {
    friends.push(newFriend);
  }
  public function addFriendSymmetric(newFriend:Person):void {
    addFriend(newFriend);
    newFriend.addFriend(this);
  }
  public function isFriendsWith(person:Person):Boolean {
    return (friends.indexOf(person) != -1);
  }
  public function isConnectedTo(toFind:Person, met:Dictionary = null):Boolean {
    var ret:Boolean = false;
    if (met == null) met = new Dictionary(true);
    for each (var contact:Person in friends) {
      if (!(contact in met)) {
        met[contact] = true;
        if (contact == toFind) {
          return true; //found them!
        } else {
          ret ||= contact.isConnectedTo(toFind, met);
        }
      }
    }
    return ret;
  }
}