// The following code is example code from 
// "ActionScript 3.0 Bible, 2nd Edition" by Roger Braunstein
// Find all of the source code on the companion website
// http://actionscriptbible.com/
//
// Copyright (c) 2010 by Wiley Publishing, Inc., Indianapolis, Indiana
//
// Permission is hereby granted, free of charge, to any person
// obtaining a copy of this software and associated documentation
// files (the "Software"), to deal in the Software without
// restriction, including without limitation the rights to use,
// copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the
// Software is furnished to do so, subject to the following
// conditions:
//
// The above copyright notice and this permission notice shall be
// included in all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
// OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
// NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
// HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
// FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
// OTHER DEALINGS IN THE SOFTWARE.

package {
  import flash.display.Sprite;
  import flash.events.MouseEvent;
  import flash.text.TextField;
  import flash.text.TextFieldAutoSize;
  import flash.text.TextFormat;
  
  public class ch9ex3 extends Sprite {
    protected var labels:Vector.<TextField>;

    protected const DEFAULT_FORMAT:TextFormat
      = new TextFormat("_sans", 12, 0x000000, true);
    protected const SELECTED_FORMAT:TextFormat
      = new TextFormat("_sans", 12, 0x00ffff, true);
    protected const MARGIN:Number = 20;

    public function ch9ex3() {
      labels = new Vector.<TextField>;
      makeMenuItem("home");
      makeMenuItem("about");
      makeMenuItem("blog");
      makeMenuItem("contact");
    }
    
    protected function makeMenuItem(label:String):void {
      var tf:TextField = new TextField();
      tf.selectable = false;
      tf.defaultTextFormat = DEFAULT_FORMAT;
      tf.text = label;
      tf.width = tf.height = 0;
      tf.autoSize = TextFieldAutoSize.LEFT;
      if (labels.length > 0) {
        var lastTF:TextField = labels[labels.length-1];
        tf.x = lastTF.x + lastTF.textWidth + MARGIN; 
      }
      addChild(tf);
      labels.push(tf);
      tf.addEventListener(MouseEvent.CLICK, onItemClick);
    }
    
    protected function onItemClick(event:MouseEvent):void {
      for each (var tf:TextField in labels) {
        tf.setTextFormat((tf == event.target)? SELECTED_FORMAT:DEFAULT_FORMAT);
      }
    }
  }
}